"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NestedLayout = exports.ActionCallback = exports.InteractiveVisibility = exports.Array = void 0;
var addon_actions_1 = require("@storybook/addon-actions");
var react_1 = __importDefault(require("react"));
var Form_1 = __importDefault(require("./Form"));
var metaforms_1 = require("metaforms");
var Array = function (args) { return (react_1.default.createElement(Form_1.default, __assign({ initialValues: { user: [{ fname: ['joe'] }] }, fields: [
        (0, metaforms_1.getObjectMeta)({
            name: 'user',
            label: 'User',
            array: true,
            fields: [
                (0, metaforms_1.getTextMeta)({
                    name: 'fname',
                    array: true,
                    label: 'First name'
                }),
                (0, metaforms_1.getTextMeta)({
                    name: 'lname',
                    label: 'Last name'
                })
            ]
        }),
        (0, metaforms_1.getTextMeta)({
            name: 'role',
            array: true,
            label: 'Role',
            validation: [
                (0, metaforms_1.requiredRule)('This field is required'),
                (0, metaforms_1.minlengthRule)('Too short', 2)
            ],
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Login',
        })
    ], onSubmit: (0, addon_actions_1.action)('onSubmit') }, args))); };
exports.Array = Array;
var InteractiveVisibility = function (args) { return (react_1.default.createElement(Form_1.default, __assign({ initialValues: {}, fields: [
        (0, metaforms_1.getCheckboxMeta)({
            name: 'visible',
            label: 'Show search',
        }),
        (0, metaforms_1.getObjectMeta)({
            name: 'search',
            label: 'Search',
            visible: { targetName: 'visible', value: true },
            fields: [
                (0, metaforms_1.getTextMeta)({
                    name: 'username',
                    label: 'Search by username',
                }),
                (0, metaforms_1.getTextMeta)({
                    name: 'term',
                    label: 'Search by term',
                    validation: [(0, metaforms_1.requiredRule)('This is required')],
                }),
            ]
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Login',
        })
    ], onSubmit: function (values, helpers) {
        (0, addon_actions_1.action)('onSubmit')(values);
        helpers.setSubmitting(false);
    } }, args))); };
exports.InteractiveVisibility = InteractiveVisibility;
var ActionCallback = function (args) { return (react_1.default.createElement(Form_1.default, __assign({ initialValues: {}, onAction: function (p, e) {
        if (p.field.id === 'prefill') {
            p.form.setFieldValue('username', 'John');
        }
        (0, addon_actions_1.action)('onAction')(p, e);
    }, fields: [
        (0, metaforms_1.getTextMeta)({
            name: 'title',
            label: 'Title'
        }),
        (0, metaforms_1.getLayoutMeta)({
            render: 'horizontal',
            fields: [
                (0, metaforms_1.getTextMeta)({
                    name: 'username',
                    label: 'Search by username',
                }),
                (0, metaforms_1.getActionMeta)({
                    id: 'prefill',
                    label: 'Prefill username',
                    control: 'button'
                }),
            ]
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Login',
        })
    ], onSubmit: function (values, helpers) {
        (0, addon_actions_1.action)('onSubmit')(values);
        helpers.setSubmitting(false);
    } }, args))); };
exports.ActionCallback = ActionCallback;
var NestedLayout = function (args) { return (react_1.default.createElement(Form_1.default, __assign({ initialValues: {}, onAction: function (p, e) {
        if (p.field.id === 'prefill') {
            p.form.setFieldValue('search.username', 'John');
        }
        (0, addon_actions_1.action)('onAction')(p, e);
    }, fields: [
        (0, metaforms_1.getTextMeta)({
            name: 'title',
            label: 'Title'
        }),
        (0, metaforms_1.getObjectMeta)({
            name: 'search',
            label: 'Search',
            fields: [
                (0, metaforms_1.getLayoutMeta)({
                    render: 'horizontal',
                    fields: [
                        (0, metaforms_1.getTextMeta)({
                            name: 'username',
                            label: 'Search by username',
                        }),
                        (0, metaforms_1.getActionMeta)({
                            id: 'prefill',
                            label: 'Prefill username',
                            control: 'button'
                        }),
                    ]
                }),
            ]
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Login',
        })
    ], onSubmit: function (values, helpers) {
        (0, addon_actions_1.action)('onSubmit')(values);
        helpers.setSubmitting(false);
    } }, args))); };
exports.NestedLayout = NestedLayout;
exports.default = {
    title: 'AntdForm',
    argTypes: {
        size: { control: { type: 'select' }, options: ['small', 'middle', 'large'] },
    },
    args: {
        size: 'middle',
    },
};
