"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SegmentedSwitch = exports.Autocomplete = exports.Multiselect = exports.DateRange = exports.Checkbox = exports.Select = exports.Date = exports.File = exports.Image = exports.Textarea = exports.Password = exports.Text = exports.Number = void 0;
var addon_actions_1 = require("@storybook/addon-actions");
var metaforms_1 = require("metaforms");
var react_1 = __importDefault(require("react"));
var Form_1 = __importDefault(require("./Form"));
require("antd/dist/antd.variable.min.css");
var handleSubmit = function (v, h) {
    (0, addon_actions_1.action)('submit')(v);
    setTimeout(function () {
        h.setSubmitting(false);
    }, 1000);
};
var Number = function (args) { return (react_1.default.createElement(Form_1.default, { fields: [
        (0, metaforms_1.getNumberMeta)({
            name: 'number',
            label: args.label,
            disabled: args.disabled,
            placeholder: args.placeholder,
            validation: [(0, metaforms_1.requiredRule)('Required field')],
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Save',
        }),
    ], onSubmit: handleSubmit })); };
exports.Number = Number;
exports.Number.args = {
    label: 'Number',
    disabled: false,
    placeholder: '',
};
var Text = function (args) { return (react_1.default.createElement(Form_1.default, { fields: [
        (0, metaforms_1.getTextMeta)({
            name: 'text',
            label: args.label,
            disabled: args.disabled,
            placeholder: args.placeholder,
            validation: [(0, metaforms_1.requiredRule)('Required field'), (0, metaforms_1.minlengthRule)('Enter at least 2 characters', 2)],
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Save',
        }),
    ], onSubmit: handleSubmit })); };
exports.Text = Text;
exports.Text.args = {
    label: 'Text',
    disabled: false,
    placeholder: '',
};
var Password = function (args) { return (react_1.default.createElement(Form_1.default, { fields: [
        (0, metaforms_1.getPasswordMeta)({
            name: 'password',
            label: args.label,
            disabled: args.disabled,
            placeholder: args.placeholder,
            validation: [(0, metaforms_1.requiredRule)('Required field'), (0, metaforms_1.minlengthRule)('Enter at least 2 characters', 2)],
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Save',
        }),
    ], onSubmit: handleSubmit })); };
exports.Password = Password;
exports.Password.args = {
    label: 'Password',
    disabled: false,
    placeholder: '',
};
var Textarea = function (args) { return (react_1.default.createElement(Form_1.default, { fields: [
        (0, metaforms_1.getTextareaMeta)({
            name: 'textarea',
            label: args.label,
            disabled: args.disabled,
            placeholder: args.placeholder,
            rows: args.rows,
            validation: [(0, metaforms_1.requiredRule)('Required field'), (0, metaforms_1.minlengthRule)('Enter at least 2 characters', 2)],
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Save',
        }),
    ], onSubmit: handleSubmit })); };
exports.Textarea = Textarea;
exports.Textarea.args = {
    label: 'Text area',
    disabled: false,
    placeholder: '',
    rows: 10,
};
var Image = function (args) { return (react_1.default.createElement(Form_1.default, { fields: [
        (0, metaforms_1.getImageMeta)({
            name: 'image',
            label: args.label,
            validation: [(0, metaforms_1.requiredRule)('Required field')],
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Save',
        }),
    ], onSubmit: handleSubmit })); };
exports.Image = Image;
exports.Image.args = {
    label: 'Image',
};
var File = function (args) { return (react_1.default.createElement(Form_1.default, { fields: [
        (0, metaforms_1.getFileMeta)({
            name: 'file',
            label: args.label,
            accept: args.accept,
            validation: [(0, metaforms_1.requiredRule)('Required field')],
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Save',
        }),
    ], onSubmit: handleSubmit })); };
exports.File = File;
exports.File.args = {
    label: 'File',
    accept: '.csv',
};
var Date = function (args) { return (react_1.default.createElement(Form_1.default, { fields: [
        (0, metaforms_1.getDateMeta)({
            name: 'date',
            label: args.label,
            disabled: args.disabled,
            placeholder: args.placeholder,
            withTimePicker: args.withTimePicker,
            validation: [(0, metaforms_1.requiredRule)('Required field')],
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Save',
        }),
    ], onSubmit: handleSubmit })); };
exports.Date = Date;
exports.Date.args = {
    label: 'Date',
    disabled: false,
    placeholder: '',
    withTimePicker: false,
};
var Select = function (args) { return (react_1.default.createElement(Form_1.default, { fields: [
        (0, metaforms_1.getSelectMeta)({
            name: 'select',
            disabled: args.disabled,
            placeholder: args.placeholder,
            label: args.label,
            options: [
                {
                    value: '1',
                    label: 'One',
                },
                {
                    value: '2',
                    label: 'Two',
                },
            ],
            validation: [(0, metaforms_1.requiredRule)('Required field')],
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Save',
        }),
    ], onSubmit: handleSubmit })); };
exports.Select = Select;
exports.Select.args = {
    disabled: false,
    placeholder: '',
    label: 'Select',
};
var Checkbox = function (args) { return (react_1.default.createElement(Form_1.default, { fields: [
        (0, metaforms_1.getCheckboxMeta)({
            name: 'checkbox',
            label: args.label,
            disabled: args.disabled,
            validation: [(0, metaforms_1.requiredRule)('Required field')],
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Save',
        }),
    ], onSubmit: handleSubmit })); };
exports.Checkbox = Checkbox;
exports.Checkbox.args = {
    label: 'Checkbox',
    disabled: false,
};
var DateRange = function (args) { return (react_1.default.createElement(Form_1.default, { initialValues: { daterange: [1645686522, 1645686522] }, fields: [
        (0, metaforms_1.getDateRangeMeta)({
            name: 'daterange',
            label: args.label,
            withTimePicker: args.withTimePicker,
            size: args.smallSize ? 'small' : 'full',
            presets: {
                lastDay: 'Last day',
                lastWeek: 'Last week',
            },
            validation: [(0, metaforms_1.requiredRule)('Required field')],
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Save',
        }),
    ], onSubmit: handleSubmit })); };
exports.DateRange = DateRange;
exports.DateRange.args = {
    label: 'Date Range',
    withTimePicker: true,
    smallSize: true,
};
var Multiselect = function (args) { return (react_1.default.createElement(Form_1.default, { fields: [
        (0, metaforms_1.getMultiSelectMeta)({
            name: 'multiselect',
            label: 'Select multiple',
            showFilterInput: args.showFilterInput,
            showSelectedCounter: args.showSelectedCounter,
            options: [
                { label: 'Dog 1', value: 1 },
                { label: 'Cat 2', value: 2 },
                { label: 'Pig 3', value: 3 },
                { label: 'Rat 4', value: 4 },
                { label: 'Dog 5', value: 5 },
                { label: 'Cat 6', value: 6 },
                { label: 'Pig 7', value: 7, style: { background: 'red' } },
                { label: 'Rat 8', value: 8 },
                { label: 'Dog 9', value: 9 },
                { label: 'Cat 10', value: 10 },
                { label: 'Pig 11', value: 11 },
                { label: 'Rat 12', value: 12 },
            ],
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Save',
        }),
    ], onSubmit: handleSubmit })); };
exports.Multiselect = Multiselect;
exports.Multiselect.args = {
    label: 'Multiselect',
    showFilterInput: true,
    showSelectedCounter: true,
};
var Autocomplete = function () { return (react_1.default.createElement(Form_1.default, { fields: [
        (0, metaforms_1.getAutocompleteMeta)({
            label: 'Autocomplete',
            name: 'autocomplete',
            validation: [(0, metaforms_1.requiredRule)('Pole je povinne')],
            options: [
                {
                    value: 'A',
                },
                {
                    value: 'B',
                },
                {
                    value: 'C',
                },
            ],
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Save',
        }),
    ], onSubmit: handleSubmit })); };
exports.Autocomplete = Autocomplete;
exports.Autocomplete.args = {
    label: 'Autocomplete',
    disabled: false,
};
var SegmentedSwitch = function (args) { return (react_1.default.createElement(Form_1.default, { layout: args.formLayout, initialValues: {
        a: 'a',
        b: 'b',
        c: 'c',
    }, fields: __spreadArray(__spreadArray([], ['first', 'second', 'third'].map(function (name) {
        return (0, metaforms_1.getSegmentedSwitch)({
            name: name,
            label: name,
            size: args.size,
            disabled: args.disabled,
            align: args.alignRight ? 'right' : undefined,
            options: [
                { label: args.showLabel && 'A Value', value: 'a', icon: args.showIcon ? 'write' : undefined },
                { label: args.showLabel && 'B Value', value: 'b', icon: args.showIcon ? 'read' : undefined },
                { label: args.showLabel && 'C Value', value: 'c', icon: args.showIcon ? 'none' : undefined },
            ],
        });
    }), true), [
        (0, metaforms_1.getSubmitMeta)({ name: 'submit', label: 'Save' }),
    ], false), onSubmit: handleSubmit })); };
exports.SegmentedSwitch = SegmentedSwitch;
exports.SegmentedSwitch.args = {
    disabled: false,
    formLayout: 'vertical',
    size: 'small',
    alignRight: false,
    showIcon: true,
    showLabel: true,
};
exports.SegmentedSwitch.argTypes = {
    formLayout: {
        options: ['horizontal', 'vertical'],
        control: { type: 'radio' },
    },
    size: {
        options: ['small', 'medium', 'large'],
        control: { type: 'radio' },
    },
};
exports.default = {
    title: 'AntdForm/Components',
};
