"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var antd_1 = require("antd");
var moment_1 = __importDefault(require("moment"));
var react_1 = __importDefault(require("react"));
var hooks_1 = require("../../hooks");
var DatePicker = react_1.default.forwardRef(function (_a, ref) {
    var withTimePicker = _a.withTimePicker, value = _a.value, onChange = _a.onChange, placeholder = _a.placeholder, disabled = _a.disabled;
    var isOpen = (0, hooks_1.useBoolean)(false);
    var handleChange = function (v) {
        onChange(withTimePicker ? v === null || v === void 0 ? void 0 : v.format('YYYY-MM-DDTHH:mm:ss') : v === null || v === void 0 ? void 0 : v.format('YYYY-MM-DD'));
    };
    return (react_1.default.createElement(antd_1.DatePicker, { disabled: disabled, placeholder: placeholder, showTime: withTimePicker, ref: ref, onOpenChange: isOpen.setValue, open: isOpen.value, onOk: handleChange, onChange: handleChange, style: { width: '100%' }, value: value ? (0, moment_1.default)(value) : undefined, format: "DD.MM.YYYY".concat(withTimePicker ? ' HH:mm' : ''), onFocus: isOpen.setTrue, onBlur: isOpen.setFalse }));
});
DatePicker.displayName = 'DatePicker';
exports.default = DatePicker;
