"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fileReader = exports.imageReader = exports.loadImage = void 0;
var loadImage = function (imageSrc) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, new Promise(function (resolve) {
                var image = new Image();
                image.crossOrigin = 'Anonymous';
                image.src = imageSrc;
                image.onload = function () {
                    resolve(image);
                };
            })];
    });
}); };
exports.loadImage = loadImage;
var imageReader = function (file, options) { return __awaiter(void 0, void 0, void 0, function () {
    var fr;
    return __generator(this, function (_a) {
        fr = new FileReader();
        return [2 /*return*/, new Promise(function (resolve, reject) {
                fr.onerror = function () {
                    fr.abort();
                    reject(new DOMException('Error reading file.'));
                };
                fr.onload = function () { return __awaiter(void 0, void 0, void 0, function () {
                    var imageSrc, canvas, img, maxw, maxh, width, height;
                    var _a, _b, _c, _d, _e;
                    return __generator(this, function (_f) {
                        switch (_f.label) {
                            case 0:
                                imageSrc = (_b = (_a = fr.result) === null || _a === void 0 ? void 0 : _a.toString()) !== null && _b !== void 0 ? _b : '';
                                canvas = document.createElement('canvas');
                                return [4 /*yield*/, (0, exports.loadImage)(imageSrc)];
                            case 1:
                                img = _f.sent();
                                maxw = (_c = options === null || options === void 0 ? void 0 : options.maxWidth) !== null && _c !== void 0 ? _c : 400;
                                maxh = (_d = options === null || options === void 0 ? void 0 : options.maxHeight) !== null && _d !== void 0 ? _d : 400;
                                width = img.width;
                                height = img.height;
                                if (width > height) {
                                    if (width > maxw) {
                                        height *= maxw / width;
                                        width = maxw;
                                    }
                                }
                                else if (height > maxh) {
                                    width *= maxh / height;
                                    height = maxh;
                                }
                                canvas.width = width;
                                canvas.height = height;
                                (_e = canvas.getContext('2d')) === null || _e === void 0 ? void 0 : _e.drawImage(img, 0, 0, width, height);
                                resolve(canvas.toDataURL('image/png'));
                                return [2 /*return*/];
                        }
                    });
                }); };
                fr.readAsDataURL(file);
            })];
    });
}); };
exports.imageReader = imageReader;
var fileReader = function (file) { return __awaiter(void 0, void 0, void 0, function () {
    var fr;
    return __generator(this, function (_a) {
        fr = new FileReader();
        return [2 /*return*/, new Promise(function (resolve, reject) {
                fr.onerror = function () {
                    fr.abort();
                    reject(new DOMException('Error reading file.'));
                };
                fr.onload = function (e) { return __awaiter(void 0, void 0, void 0, function () {
                    var _a;
                    return __generator(this, function (_b) {
                        resolve((_a = e === null || e === void 0 ? void 0 : e.target) === null || _a === void 0 ? void 0 : _a.result);
                        return [2 /*return*/];
                    });
                }); };
                fr.readAsDataURL(file);
            })];
    });
}); };
exports.fileReader = fileReader;
