import { InputRef as $InputRef } from 'antd';
import React from 'react';
import { TextMetaProps } from 'metaforms';
import { NumberMetaProps, PasswordMetaProps } from '@falsy/metacore';
export declare type InputRef = $InputRef;
interface InputEvents {
    onChange: (event: React.ChangeEvent<HTMLInputElement>) => void;
    onFocus?: (event: React.FocusEvent<HTMLInputElement>) => void;
    onBlur?: (event: React.FocusEvent<HTMLInputElement>) => void;
}
export declare type InputProps = (TextMetaProps & {
    value: string;
} | NumberMetaProps & {
    value: number;
} | PasswordMetaProps & {
    value: string;
}) & InputEvents;
declare const Input: React.ForwardRefExoticComponent<InputProps & React.RefAttributes<unknown>>;
export default Input;
