"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var antd_1 = require("antd");
var fuse_js_1 = __importDefault(require("fuse.js"));
var ramda_1 = require("ramda");
var react_1 = __importStar(require("react"));
var styled_components_1 = __importStar(require("styled-components"));
var hooks_1 = require("../../hooks");
var useSelection_1 = require("../../hooks/useSelection");
var Input_1 = __importDefault(require("./Input"));
var ListItem = (0, styled_components_1.default)(antd_1.List.Item)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  ", "\n  cursor: pointer;\n"], ["\n  ", "\n  cursor: pointer;\n"])), function (_a) {
    var $focused = _a.$focused;
    return $focused && (0, styled_components_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n      background: rgba(180, 180, 180, 0.1);\n    "], ["\n      background: rgba(180, 180, 180, 0.1);\n    "])));
});
var ListItemContent = styled_components_1.default.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  cursor: pointer;\n  display: flex;\n  column-gap: 10px;\n"], ["\n  cursor: pointer;\n  display: flex;\n  column-gap: 10px;\n"])));
var ToggleResults = styled_components_1.default.div(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  padding: 0.5em 0;\n\n  & > span {\n    margin-left: 0.5em;\n  }\n"], ["\n  padding: 0.5em 0;\n\n  & > span {\n    margin-left: 0.5em;\n  }\n"])));
var Multiselect = react_1.default.forwardRef(function (_a, ref) {
    var _b = _a.options, options = _b === void 0 ? [] : _b, _c = _a.value, value = _c === void 0 ? [] : _c, onChange = _a.onChange, placeholder = _a.placeholder, disabled = _a.disabled, onFocus = _a.onFocus, onBlur = _a.onBlur, _d = _a.showSelectedCounter, showSelectedCounter = _d === void 0 ? true : _d, _e = _a.showFilterInput, showFilterInput = _e === void 0 ? true : _e;
    var focusedRef = (0, react_1.useRef)(null);
    var _f = (0, react_1.useState)(), search = _f[0], setSearch = _f[1];
    var _g = (0, react_1.useState)(), focused = _g[0], setFocused = _g[1];
    var inputFocused = (0, hooks_1.useBoolean)(false);
    var showSelected = (0, hooks_1.useBoolean)(false);
    var shouldRegisterKeyPress = Boolean(disabled || !inputFocused.value);
    var downPress = (0, hooks_1.useKeyPress)(hooks_1.KeyboardKey.arrowDown, shouldRegisterKeyPress);
    var upPress = (0, hooks_1.useKeyPress)(hooks_1.KeyboardKey.arrowUp, shouldRegisterKeyPress);
    var spacePress = (0, hooks_1.useKeyPress)(hooks_1.KeyboardKey.space, shouldRegisterKeyPress);
    var _h = (0, react_1.useState)(options), filteredOptions = _h[0], setFilteredOptions = _h[1];
    var handleClick = function (itemValue) {
        var _a;
        if (disabled) {
            return;
        }
        var opts = (0, useSelection_1.toggleSelection)(itemValue, value);
        var visibleOptions = showSelected.value ? filteredOptions.filter(function (o) { return opts.includes(o.value); }) : filteredOptions;
        if (inputFocused.value && !visibleOptions.find(function (vo) { return vo.value === focused; })) {
            setFocused((_a = (0, ramda_1.head)(visibleOptions)) === null || _a === void 0 ? void 0 : _a.value);
        }
        setFilteredOptions(visibleOptions);
        onChange(opts);
    };
    var handleSelectAll = function (checked) {
        onChange(checked ? options.map(function (opt) { return opt.value; }) : []);
    };
    var handleInputFocus = function (event) {
        var _a;
        inputFocused.setTrue();
        setFocused((_a = (0, ramda_1.head)(filteredOptions)) === null || _a === void 0 ? void 0 : _a.value);
        onFocus === null || onFocus === void 0 ? void 0 : onFocus(event);
    };
    var handleInputBlur = function (event) {
        inputFocused.setFalse();
        setFocused(undefined);
        onBlur === null || onBlur === void 0 ? void 0 : onBlur(event);
    };
    (0, react_1.useEffect)(function () {
        var _a;
        var fuse = new fuse_js_1.default(options, { keys: ['label'] });
        // eslint-disable-next-line @typescript-eslint/ban-ts-comment
        // @ts-ignore
        var filteredOptions = search ? fuse.search(search).map(function (result) { return result.item; }) : options;
        var visibleOptions = showSelected.value ? filteredOptions.filter(function (o) { return value.includes(o.value); }) : filteredOptions;
        setFilteredOptions(visibleOptions);
        setFocused(inputFocused.value ? (_a = (0, ramda_1.head)(visibleOptions)) === null || _a === void 0 ? void 0 : _a.value : undefined);
    }, [search, options, showSelected.value]);
    (0, react_1.useEffect)(function () {
        if (spacePress && focused) {
            handleClick(focused);
        }
    }, [spacePress]);
    (0, react_1.useEffect)(function () {
        var curr = focusedRef === null || focusedRef === void 0 ? void 0 : focusedRef.current;
        if (curr) {
            curr.scrollIntoView({ behavior: 'smooth', block: 'center' });
        }
    }, [focused]);
    (0, react_1.useEffect)(function () {
        var _a, _b;
        if (inputFocused.value) {
            var focusedOptionIdx = filteredOptions.findIndex(function (o) { return o.value === focused; });
            if (downPress) {
                var newIndex = focusedOptionIdx + 1 >= filteredOptions.length ? filteredOptions.length - 1 : focusedOptionIdx + 1;
                return setFocused((_a = filteredOptions[newIndex]) === null || _a === void 0 ? void 0 : _a.value);
            }
            if (upPress) {
                var newIndex = focusedOptionIdx - 1 < 0 ? 0 : focusedOptionIdx - 1;
                return setFocused((_b = filteredOptions[newIndex]) === null || _b === void 0 ? void 0 : _b.value);
            }
        }
    }, [downPress, upPress]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        showFilterInput && (react_1.default.createElement(Input_1.default, { ref: ref, placeholder: placeholder, name: "search", type: "text", value: search, onChange: function (e) { return setSearch(e.target.value); }, onFocus: handleInputFocus, onBlur: handleInputBlur })),
        react_1.default.createElement(ToggleResults, null,
            react_1.default.createElement("span", null,
                react_1.default.createElement(antd_1.Checkbox, { checked: value.length && value.length === options.length, indeterminate: value.length && value.length < options.length, onChange: function (e) { return handleSelectAll(e.target.checked); } }, "Ozna\u010Dit v\u0161e")),
            showSelectedCounter && (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(antd_1.Checkbox, { checked: showSelected.value, onChange: function (e) { return showSelected.setValue(e.target.checked); } }),
                react_1.default.createElement("span", null,
                    "Zobrazit pouze vybran\u00E9 ",
                    value && react_1.default.createElement(antd_1.Badge, { size: "small", count: value.length }))))),
        react_1.default.createElement(antd_1.List, { bordered: true, size: "small", style: { maxHeight: '200px', overflow: 'auto' }, dataSource: filteredOptions, renderItem: function (item) {
                var isSelected = value.includes(item.value);
                var isFocused = focused === item.value;
                return (react_1.default.createElement(ListItem, { "$focused": isFocused, onClick: function () { return handleClick(item.value); }, style: item.style },
                    react_1.default.createElement(ListItemContent, { ref: isFocused ? focusedRef : undefined },
                        react_1.default.createElement(antd_1.Checkbox, { disabled: disabled, checked: isSelected }),
                        item.label)));
            } })));
});
Multiselect.displayName = 'Multiselect';
exports.default = Multiselect;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
