"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tabs = exports.ValidationHorizontal = exports.Validation = exports.Default = void 0;
var addon_actions_1 = require("@storybook/addon-actions");
var react_1 = __importDefault(require("react"));
var Form_1 = __importDefault(require("../Form"));
var metaforms_1 = require("metaforms");
var Default = function (args) { return (react_1.default.createElement(Form_1.default, __assign({ initialValues: { search: { valid: true } }, fields: [
        (0, metaforms_1.getObjectMeta)({
            name: 'search',
            label: 'Search',
            fields: [
                (0, metaforms_1.getTextMeta)({
                    name: 'term',
                    label: 'Search term'
                }),
                (0, metaforms_1.getCheckboxMeta)({
                    name: 'valid',
                    label: 'Valid'
                })
            ]
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Login',
        })
    ], onSubmit: function (values, helpers) {
        (0, addon_actions_1.action)('onSubmit')(values);
        helpers.setSubmitting(false);
    } }, args))); };
exports.Default = Default;
var Validation = function (args) { return (react_1.default.createElement(Form_1.default, __assign({ fields: [
        (0, metaforms_1.getObjectMeta)({
            name: 'search',
            label: 'Search',
            validation: [
                (0, metaforms_1.isTruthyRule)('One of the fields is required'),
            ],
            fields: [
                (0, metaforms_1.getTextMeta)({
                    name: 'term',
                    label: 'Search term'
                }),
                (0, metaforms_1.getCheckboxMeta)({
                    name: 'valid',
                    label: 'Valid'
                })
            ]
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Login',
        })
    ], onSubmit: function (values, helpers) {
        (0, addon_actions_1.action)('onSubmit')(values);
        helpers.setSubmitting(false);
    } }, args))); };
exports.Validation = Validation;
var ValidationHorizontal = function (args) { return (react_1.default.createElement(Form_1.default, __assign({ fields: [
        (0, metaforms_1.getTextMeta)({ name: 'title', placeholder: 'Název', label: 'Název', validation: [(0, metaforms_1.requiredRule)('Pole je povinné')] }),
        (0, metaforms_1.getObjectMeta)({
            name: 'value',
            label: 'Výraz',
            array: true,
            arrayInitialValues: { isEnabled: true },
            fields: [
                (0, metaforms_1.getLayoutMeta)({
                    render: 'horizontal',
                    fields: [
                        (0, metaforms_1.getTextMeta)({ name: 'phrase', label: 'Hodnota', validation: [(0, metaforms_1.requiredRule)('Hodnota je povinná')] }),
                        (0, metaforms_1.getTextMeta)({ name: 'note', label: 'Poznámka' }),
                        (0, metaforms_1.getCheckboxMeta)({ name: 'isEnabled', label: 'Hledat?' }),
                    ],
                }),
            ],
        }),
        (0, metaforms_1.getCheckboxMeta)({ name: 'isEnabled', label: 'Zapnout' }),
        (0, metaforms_1.getTextMeta)({ name: 'note', placeholder: 'Poznámka', label: 'Poznámka' }),
        (0, metaforms_1.getSubmitMeta)({ name: 'submit', label: 'Uložit' }),
    ], onSubmit: function (values, helpers) {
        (0, addon_actions_1.action)('onSubmit')(values);
        helpers.setSubmitting(false);
    } }, args))); };
exports.ValidationHorizontal = ValidationHorizontal;
var Tabs = function () { return (react_1.default.createElement(Form_1.default, { fields: [
        (0, metaforms_1.getObjectMeta)({
            name: 'tabs',
            render: 'tabs',
            fields: [
                (0, metaforms_1.getTextMeta)({
                    name: 'term',
                    label: 'Search term'
                }),
                (0, metaforms_1.getCheckboxMeta)({
                    name: 'valid',
                    label: 'Valid'
                })
            ]
        }),
        (0, metaforms_1.getSubmitMeta)({
            name: 'submit',
            label: 'Login',
        })
    ], onSubmit: function (values, helpers) {
        (0, addon_actions_1.action)('onSubmit')(values);
        helpers.setSubmitting(false);
    } })); };
exports.Tabs = Tabs;
exports.default = {
    title: 'AntdForm/ObjectType',
    argTypes: {
        size: { control: { type: 'select' }, options: ['small', 'middle', 'large'] },
    },
    args: {
        size: 'middle',
    },
};
