"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SegmentedSwitch = void 0;
var antd_1 = require("antd");
var icons_1 = require("@ant-design/icons");
var react_1 = __importDefault(require("react"));
var getIcon = function (icon) {
    switch (icon) {
        case 'write':
            return react_1.default.createElement(icons_1.EditOutlined, null);
        case 'read':
            return react_1.default.createElement(icons_1.EyeOutlined, null);
        case 'none':
            return react_1.default.createElement(icons_1.StopOutlined, null);
        default:
            return undefined;
    }
};
var SegmentedSwitch = function (_a) {
    var name = _a.name, value = _a.value, onChange = _a.onChange, options = _a.options, disabled = _a.disabled, size = _a.size;
    var defaultOptions = [
        { label: 'Vše', value: undefined },
        { label: 'Ano', value: 'ano' },
        { label: 'Ne', value: 'ne' },
    ];
    return (react_1.default.createElement(antd_1.Segmented, { name: name, options: (options || defaultOptions).map(function (option) { return ({ label: option.label, value: option.label, disabled: option.disabled, icon: getIcon(option.icon) }); }), onChange: function (value) { return onChange(value); }, value: value, disabled: disabled, size: size }));
};
exports.SegmentedSwitch = SegmentedSwitch;
