"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var antd_1 = require("antd");
var react_1 = __importDefault(require("react"));
var FormItem_1 = __importDefault(require("./FormItem"));
var Select = react_1.default.forwardRef(function (_a, ref) {
    var value = _a.value, name = _a.name, label = _a.label, disabled = _a.disabled, options = _a.options, onChange = _a.onChange, error = _a.error, onFocus = _a.onFocus, placeholder = _a.placeholder, onBlur = _a.onBlur;
    return (react_1.default.createElement(FormItem_1.default, { label: label, errorMessage: error },
        react_1.default.createElement(antd_1.Select, { ref: ref, id: name, disabled: disabled, value: value || '', onChange: onChange, onBlur: onBlur, onFocus: onFocus, placeholder: placeholder, "data-test-id": "form-select-".concat(name) }, (options || []).map(function (option) { return (react_1.default.createElement(antd_1.Select.Option, { value: option.value, key: option.value }, option.label || option.value)); }))));
});
Select.displayName = 'Select';
exports.default = Select;
