"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorMessage = exports.InputWrapper = exports.Label = void 0;
var antd_1 = require("antd");
var react_1 = __importDefault(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var LabelStyled = styled_components_1.default.label(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  color: ", ";\n"], ["\n  color: ", ";\n"])), function (props) { return (props.hasError ? 'red' : 'inherit'); });
var AsteriskStyled = styled_components_1.default.span(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  padding-left: 2px;\n  cursor: help;\n"], ["\n  padding-left: 2px;\n  cursor: help;\n"])));
var Asterisk = function () { return (react_1.default.createElement(AsteriskStyled, null,
    react_1.default.createElement(antd_1.Tooltip, { title: "Required field" }, "*"))); };
var Label = function (_a) {
    var hasError = _a.hasError, fieldId = _a.fieldId, label = _a.label, isRequired = _a.isRequired, children = _a.children;
    return (react_1.default.createElement(LabelStyled, { hasError: hasError, htmlFor: fieldId, "data-test-id": "form-label-for-".concat(fieldId) },
        label,
        isRequired && react_1.default.createElement(Asterisk, null),
        children));
};
exports.Label = Label;
exports.InputWrapper = styled_components_1.default.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  width: 100%;\n  padding-bottom: 1.3em;\n  position: relative;\n  margin-bottom: 0.2em;\n"], ["\n  width: 100%;\n  padding-bottom: 1.3em;\n  position: relative;\n  margin-bottom: 0.2em;\n"])));
var ErrorMessageStyled = styled_components_1.default.div(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  color: red;\n  height: 1.5em;\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n"], ["\n  color: red;\n  height: 1.5em;\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n"])));
var ErrorMessage = function (_a) {
    var message = _a.message, name = _a.name;
    return (react_1.default.createElement(ErrorMessageStyled, { "data-test-id": "form-error-message-".concat(name) }, message));
};
exports.ErrorMessage = ErrorMessage;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
