import React from 'react';
import { FormikContextType, FormikHelpers, FormikProps, ArrayHelpers, FieldHelperProps, FieldInputProps, FieldMetaProps } from 'formik';
import { MetaField, MetaFormValues, MetaFieldValue, ObjectMetaProps, ActionMetaProps, LayoutMetaProps } from '@falsy/metacore';
declare type FormContext = FormikContextType<MetaFormValues>;
declare type FormHelpers = FormikHelpers<MetaFormValues>;
export interface ActionRenderProps {
    onAction: (e: React.MouseEvent<HTMLElement>) => void;
    field: ActionMetaProps;
}
export interface ControlRenderProps {
    ref: any;
    form: FormContext;
    field: MetaField;
    input: FieldInputProps<MetaFieldValue>;
    meta: FieldMetaProps<MetaFieldValue>;
    helpers: FieldHelperProps<MetaFieldValue>;
}
export interface ObjectRenderProps {
    children: JSX.Element[];
    field: ObjectMetaProps;
    form: FormContext;
    meta: FieldMetaProps<MetaFieldValue>;
}
export interface ArrayRenderProps {
    children: JSX.Element[];
    field: MetaField;
    arrayHelpers: ArrayHelpers;
    form: FormContext;
    meta: FieldMetaProps<MetaFieldValue>;
}
export interface LayoutRenderProps {
    children: JSX.Element[];
    field: LayoutMetaProps;
    form: FormContext;
}
export declare type ComponentRenderProps = ControlRenderProps | ObjectRenderProps | ArrayRenderProps | ActionRenderProps | LayoutRenderProps;
export interface IProps {
    fields: MetaField[];
    values?: MetaFormValues;
    onSubmit: (values: MetaFormValues, helpers: FormHelpers) => void;
    formikProps?: Partial<FormikProps<MetaFormValues>>;
    components: (q: ComponentRenderProps) => JSX.Element;
    onAction?: (p: {
        field: ActionMetaProps;
        form: FormContext;
    }, e: React.MouseEvent<HTMLElement>) => void;
}
export declare const isControlAction: (c: ComponentRenderProps) => c is ActionRenderProps;
export declare const isControlArray: (c: ComponentRenderProps) => c is ArrayRenderProps;
export declare const isControlObject: (c: ComponentRenderProps) => c is ObjectRenderProps;
export declare const isControlLayout: (c: ComponentRenderProps) => c is LayoutRenderProps;
declare const MetaForm: (props: IProps) => JSX.Element;
export default MetaForm;
