"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isControlLayout = exports.isControlObject = exports.isControlArray = exports.isControlAction = void 0;
var react_1 = __importStar(require("react"));
var formik_1 = require("formik");
var metaforms_1 = require("metaforms");
var ramda_1 = require("ramda");
var ErrorFocus = function (_a) {
    var fieldRefs = _a.fieldRefs;
    var formik = (0, formik_1.useFormikContext)();
    (0, react_1.useEffect)(function () {
        if (!formik.isSubmitting && !formik.isValid) {
            var entry = Object.entries(fieldRefs.current).find(function (_a) {
                var name = _a[0];
                return !!(0, ramda_1.view)((0, ramda_1.lensPath)(name.split('.')), formik.errors);
            });
            if (entry) {
                var errFieldRef = entry[1];
                if (errFieldRef && 'focus' in errFieldRef) {
                    errFieldRef.focus();
                }
            }
        }
    }, [formik.isSubmitting]);
    return null;
};
var isControlAction = function (c) { return (0, metaforms_1.isAction)(c.field); };
exports.isControlAction = isControlAction;
var isControlArray = function (c) { return !(0, metaforms_1.isAction)(c.field) && !(0, metaforms_1.isLayout)(c.field) && c.field.array === true; };
exports.isControlArray = isControlArray;
var isControlObject = function (c) { return (0, metaforms_1.isObject)(c.field); };
exports.isControlObject = isControlObject;
var isControlLayout = function (c) { return (0, metaforms_1.isLayout)(c.field); };
exports.isControlLayout = isControlLayout;
var MetaForm = function (props) {
    var fieldRefs = (0, react_1.useRef)({});
    var Field = function (_a) {
        var _b, _c, _d;
        var field = _a.field;
        var _e = (0, formik_1.useField)(field.name), input = _e[0], meta = _e[1], helpers = _e[2];
        var form = (0, formik_1.useFormikContext)();
        var ref = function (el) {
            var _a;
            var _b;
            var current = (_b = fieldRefs.current) !== null && _b !== void 0 ? _b : {};
            fieldRefs.current = __assign(__assign({}, current), (_a = {}, _a[field.name] = el, _a));
        };
        if (field.visible) {
            if ((0, formik_1.getIn)(form.values, field.visible.targetName) !== field.visible.value) {
                return null;
            }
        }
        if ((0, metaforms_1.isAction)(field)) {
            return props.components({
                onAction: function (e) {
                    props.onAction({ form: form, field: field }, e);
                },
                field: field,
            });
        }
        if ((0, metaforms_1.isLayout)(field)) {
            var children = (_b = field === null || field === void 0 ? void 0 : field.fields) === null || _b === void 0 ? void 0 : _b.map(function (f) { return react_1.default.createElement(Field, { key: f.name, field: __assign(__assign({}, f), { name: "".concat(field.name).concat(f.name) }) }); });
            return props.components({ children: children, field: field, form: form });
        }
        if (field.array) {
            var children_1 = (_c = (0, formik_1.getIn)(form.values, field.name)) === null || _c === void 0 ? void 0 : _c.map(function (_, index) {
                var name = "".concat(field.name, ".").concat(index);
                return react_1.default.createElement(Field, { key: name, field: __assign(__assign({}, field), { array: false, name: name }) });
            });
            return (react_1.default.createElement(formik_1.FieldArray, { name: field.name, render: function (arrayHelpers) { return props.components({ children: children_1, field: field, arrayHelpers: arrayHelpers, form: form, meta: meta }); } }));
        }
        if ((0, metaforms_1.isObject)(field)) {
            var children = (_d = field === null || field === void 0 ? void 0 : field.fields) === null || _d === void 0 ? void 0 : _d.map(function (f) {
                var name = "".concat(field.name, ".").concat(f.name);
                return react_1.default.createElement(Field, { key: name, field: __assign(__assign({}, f), { name: name }) });
            });
            return props.components({ children: children, field: field, form: form, meta: meta });
        }
        return props.components({ field: field, ref: ref, input: input, meta: meta, helpers: helpers, form: form });
    };
    (0, react_1.useEffect)(function () {
        setTimeout(function () {
            Object.values(fieldRefs.current)[0].focus();
        }, 200);
    }, []);
    return (react_1.default.createElement(formik_1.Formik, __assign({}, props.formikProps, { initialValues: props.values || {}, validate: function (formikValues) {
            return (0, metaforms_1.validateForm)(props.fields, formikValues);
        }, onSubmit: function (values, formikHelpers) {
            return props.onSubmit(values, formikHelpers);
        } }),
        react_1.default.createElement(formik_1.Form, null,
            react_1.default.createElement(ErrorFocus, { fieldRefs: fieldRefs }),
            props.fields.map((function (field) { return (react_1.default.createElement(Field, { key: field.name, field: field })); })))));
};
exports.default = MetaForm;
