"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Basic = void 0;
var Form_1 = __importStar(require("./Form"));
var react_1 = __importDefault(require("react"));
var metaforms_1 = require("metaforms");
var addon_actions_1 = require("@storybook/addon-actions");
var Form_2 = require("./Form");
var values = {
    user: {
        name: 'John Doe'
    },
    roles: [{ name: 'Admin' }, { name: 'Superuser' }],
    friends: ['Karel', 'Ondra']
};
var fields = [
    (0, metaforms_1.getObjectMeta)({
        name: 'roles',
        array: true,
        validation: [
            (0, metaforms_1.requiredRule)('Please enter at least one role'),
        ],
        fields: [
            (0, metaforms_1.getTextMeta)({
                name: 'name',
                label: 'Name',
                validation: [
                    (0, metaforms_1.requiredRule)('Please enter role name')
                ],
            })
        ],
    }),
    (0, metaforms_1.getTextMeta)({
        name: 'friends',
        array: true,
        label: 'Friends',
    }),
    (0, metaforms_1.getSubmitMeta)({
        name: 'submit',
        label: 'Submit',
    })
];
var Label = function (props) { return (react_1.default.createElement("label", { htmlFor: props.fieldId },
    props.label,
    props.isRequired && '*',
    props.children)); };
var Submit = function (_a) {
    var isLoading = _a.isLoading, label = _a.label, name = _a.name;
    return (react_1.default.createElement("button", { name: name, type: "submit" }, isLoading ? 'Loading...' : label));
};
var Input = react_1.default.forwardRef(function (props, ref) { return (react_1.default.createElement("div", null,
    props.label && react_1.default.createElement(Label, { fieldId: props.name, label: props.label, isRequired: (0, metaforms_1.isRequired)(props.validation) }),
    react_1.default.createElement("input", { ref: ref, name: props.name, value: props.value, onChange: props.onChange, onBlur: props.onBlur }),
    props.errorMessage ? react_1.default.createElement("div", null, props.errorMessage) : null)); });
Input.displayName = 'Input';
var Basic = function () {
    return (react_1.default.createElement(Form_1.default, { values: values, onSubmit: function (v, h) {
            (0, addon_actions_1.action)('onSubmit')(v);
            setTimeout(function () {
                h.setSubmitting(false);
            }, 1000);
        }, fields: fields, components: function (componentProps) {
            if ((0, Form_2.isControlArray)(componentProps)) {
                var children = componentProps.children, arrayHelpers_1 = componentProps.arrayHelpers;
                return react_1.default.createElement(react_1.default.Fragment, null, children === null || children === void 0 ? void 0 :
                    children.map(function (c, idx) { return react_1.default.createElement(react_1.default.Fragment, { key: idx },
                        c,
                        " ",
                        react_1.default.createElement("button", { type: "button", onClick: function () { return arrayHelpers_1.remove(idx); } }, "Remove")); }),
                    react_1.default.createElement("br", null),
                    react_1.default.createElement("button", { type: "button", onClick: function () { return arrayHelpers_1.push(null); } }, "Add"),
                    react_1.default.createElement("br", null),
                    react_1.default.createElement("br", null));
            }
            if ((0, Form_2.isControlObject)(componentProps)) {
                var children = componentProps.children;
                return react_1.default.createElement("div", { style: { border: '2px solid lightblue', padding: '1em 0', marginBottom: '1em' } }, children);
            }
            if ((0, Form_2.isControlAction)(componentProps)) {
                return react_1.default.createElement("button", null, componentProps.field.label);
            }
            if ((0, Form_1.isControlLayout)(componentProps)) {
                return null;
            }
            var field = componentProps.field, meta = componentProps.meta, ref = componentProps.ref, form = componentProps.form, input = componentProps.input;
            switch (field.type) {
                case 'text':
                    return react_1.default.createElement(Input, { ref: ref, name: field.name, label: field.label, value: input.value, onChange: input.onChange, onBlur: input.onBlur, errorMessage: meta.error });
                case 'submit':
                    return react_1.default.createElement(Submit, { isLoading: form.isSubmitting, name: field.name, label: field.label });
                default:
                    return react_1.default.createElement(react_1.default.Fragment, null);
            }
        } }));
};
exports.Basic = Basic;
exports.default = {
    title: 'Form',
};
