"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.KeyboardKey = void 0;
var react_1 = __importStar(require("react"));
var KeyboardKey;
(function (KeyboardKey) {
    KeyboardKey["arrowDown"] = "ArrowDown";
    KeyboardKey["arrowUp"] = "ArrowUp";
    KeyboardKey["space"] = " ";
})(KeyboardKey = exports.KeyboardKey || (exports.KeyboardKey = {}));
var useKeyPress = function (targetKey, disabled) {
    var _a = (0, react_1.useState)(false), keyPressed = _a[0], setKeyPressed = _a[1];
    var downHandler = function (e) {
        if (e.key === targetKey) {
            e.preventDefault();
            setKeyPressed(true);
        }
    };
    var upHandler = function (e) {
        if (e.key === targetKey) {
            e.preventDefault();
            setKeyPressed(false);
        }
    };
    react_1.default.useEffect(function () {
        if (!disabled) {
            window.addEventListener('keydown', downHandler);
            window.addEventListener('keyup', upHandler);
            return function () {
                window.removeEventListener('keydown', downHandler);
                window.removeEventListener('keyup', upHandler);
            };
        }
        else {
            window.removeEventListener('keydown', downHandler);
            window.removeEventListener('keyup', upHandler);
        }
        return;
    }, [disabled]);
    return keyPressed;
};
exports.default = useKeyPress;
