export interface IUseSelection<T> {
    isSelected: (item: T) => boolean;
    getIndex: (item: T) => number;
    list: T[];
    toggle: (item: T) => void;
    remove: (item: T) => void;
    add: (item: T) => void;
    clear: () => void;
    length: number;
}
export declare const addSelection: <T>(item: T, list: T[]) => T[];
export declare const removeSelection: <T>(item: T, list: T[]) => T[];
export declare const toggleSelection: <T>(item: T, list: T[]) => T[];
declare const useSelection: <T>(initial?: T[]) => IUseSelection<T>;
export default useSelection;
