"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toggleSelection = exports.removeSelection = exports.addSelection = void 0;
var react_1 = require("react");
var addSelection = function (item, list) { return __spreadArray(__spreadArray([], list, true), [item], false); };
exports.addSelection = addSelection;
var removeSelection = function (item, list) { return list.filter(function (s) { return s !== item; }); };
exports.removeSelection = removeSelection;
var toggleSelection = function (item, list) { return (list.includes(item) ? (0, exports.removeSelection)(item, list) : (0, exports.addSelection)(item, list)); };
exports.toggleSelection = toggleSelection;
var useSelection = function (initial) {
    var _a = (0, react_1.useState)(initial || []), list = _a[0], setList = _a[1];
    var isSelected = function (item) { return list.includes(item); };
    var add = function (item) {
        setList((0, exports.addSelection)(item, list));
    };
    var remove = function (item) {
        setList((0, exports.removeSelection)(item, list));
    };
    var toggle = function (item) {
        setList((0, exports.toggleSelection)(item, list));
    };
    return {
        isSelected: isSelected,
        list: list,
        toggle: toggle,
        remove: remove,
        add: add,
        length: list === null || list === void 0 ? void 0 : list.length,
        clear: function () {
            setList([]);
        },
        getIndex: function (item) { return list.findIndex(function (s) { return s === item; }); },
    };
};
exports.default = useSelection;
